**DO NOT READ THIS FILE ON GITHUB, GUIDES ARE PUBLISHED ON http://guides.rubyonrails.org.**

Ruby on Rails 5.2 Release Notes
===============================

Highlights in Rails 5.2:

* Active Storage
* Redis Cache Store
* HTTP/2 Early hints support
* Credentials
* Default Content Security Policy

These release notes cover only the major changes. To learn about various bug
fixes and changes, please refer to the change logs or check out the [list of
commits](https://github.com/rails/rails/commits/5-2-stable) in the main Rails
repository on GitHub.

--------------------------------------------------------------------------------

Upgrading to Rails 5.2
----------------------

If you're upgrading an existing application, it's a great idea to have good test
coverage before going in. You should also first upgrade to Rails 5.1 in case you
haven't and make sure your application still runs as expected before attempting
an update to Rails 5.2.


Major Features
--------------

### Active Storage

[README](https://github.com/rails/rails/blob/d3893ec38ec61282c2598b01a298124356d6b35a/activestorage/README.md)

### Redis Cache Store

[Pull Request](https://github.com/rails/rails/pull/31134)


### HTTP/2 Early hints support

[Pull Request](https://github.com/rails/rails/pull/30744)


### Credentials

[Pull Request](https://github.com/rails/rails/pull/30067)


### Default Content Security Policy

[Pull Request](https://github.com/rails/rails/pull/31162)

Incompatibilities
-----------------

ToDo

Railties
--------

Please refer to the [Changelog][railties] for detailed changes.

### Removals

ToDo

### Notable changes

ToDo

Action Cable
-----------

Please refer to the [Changelog][action-cable] for detailed changes.

### Notable changes

ToDo

Action Pack
-----------

Please refer to the [Changelog][action-pack] for detailed changes.

### Removals

ToDo

### Deprecations

ToDo

### Notable changes

ToDo

Action View
-------------

Please refer to the [Changelog][action-view] for detailed changes.

### Removals

ToDo

### Deprecations

ToDo

### Notable changes

ToDo

Action Mailer
-------------

Please refer to the [Changelog][action-mailer] for detailed changes.

### Notable changes

ToDo

Active Record
-------------

Please refer to the [Changelog][active-record] for detailed changes.

ToDo

### Deprecations

ToDo

### Notable changes

ToDo

Active Model
------------

Please refer to the [Changelog][active-model] for detailed changes.

### Removals

ToDo

### Notable changes

ToDo

Active Storage
--------------

Please refer to the [Changelog][active-support] for detailed changes.

### Notable changes

ToDo

Active Support
--------------

Please refer to the [Changelog][active-support] for detailed changes.

### Removals

ToDo

### Deprecations

ToDo

### Notable changes

ToDo

Active Job
-----------

Please refer to the [Changelog][active-job] for detailed changes.

### Removals

ToDo

### Notable changes

ToDo

Credits
-------

See the
[full list of contributors to Rails](http://contributors.rubyonrails.org/) for
the many people who spent many hours making Rails, the stable and robust
framework it is. Kudos to all of them.

[railties]:       https://github.com/rails/rails/blob/5-2-stable/railties/CHANGELOG.md
[action-pack]:    https://github.com/rails/rails/blob/5-2-stable/actionpack/CHANGELOG.md
[action-view]:    https://github.com/rails/rails/blob/5-2-stable/actionview/CHANGELOG.md
[action-mailer]:  https://github.com/rails/rails/blob/5-2-stable/actionmailer/CHANGELOG.md
[action-cable]:   https://github.com/rails/rails/blob/5-2-stable/actioncable/CHANGELOG.md
[active-record]:  https://github.com/rails/rails/blob/5-2-stable/activerecord/CHANGELOG.md
[active-model]:   https://github.com/rails/rails/blob/5-2-stable/activemodel/CHANGELOG.md
[active-storage]: https://github.com/rails/rails/blob/5-2-stable/activestorage/CHANGELOG.md
[active-support]: https://github.com/rails/rails/blob/5-2-stable/activesupport/CHANGELOG.md
[active-job]:     https://github.com/rails/rails/blob/5-2-stable/activejob/CHANGELOG.md
